const log = require('../log');

const TAG = '[MOCKTMP]';
const common = require('./common/mapping');
const pressure = require('./pressure/mapping');

const MAPPINGS = {
  common,
  pressure,
};

function ThingManager() {
  // log.d(TAG, 'yes!!!!!!!!' + JSON.stringify(MAPPINGS));
}

function getThing(id) {
  var thing;
  for (const key in MAPPINGS) {
    MAPPINGS[key].forEach((item) => {
      if (item.ids.includes(id)) {
        thing = item.thing;
      }
    });
  }
  return thing;
}

/**
 * 获取设备列表 getDeviceList
 * @param status = util.format("deviceState=%s", state) state: online offline or null
 * @return {Array}
 */
ThingManager.prototype.getIds = function () {
  const ids = [];
  for (const key in MAPPINGS) {
    MAPPINGS[key].forEach((item) => {
      item.ids.forEach((id) => {
        ids.push(id);
      });
    });
  }
  return ids;
};

/**
 * getDeviceProfile
 * @param id arr
 */
ThingManager.prototype.getProfile = function (id) {
  var profile;
  const thing = getThing(id);
  if (thing && thing.profile) {
    profile = thing.profile;
  }
  return profile;
};

ThingManager.prototype.getService = function (id) {
  const thing = getThing(id);
  if (thing && thing.handle) {
    return thing.handle;
  }
};
module.exports = new ThingManager();
