const util = require('util');
const Tag = require('../../utils/constant');
const valuecomparer = require('./comparer.js');
const log = require('../../utils/log');

const TAG = 'IFTTT_DeviceTrigger';

var DeviceTrigger = function(params, sid, eventBus) {
    this.params = params;
    this.fullfilled = false;
    this.id = util.format("%s_%s", this.params[Tag.PRODUCTKEY], this.params[Tag.DEVICENAME]);
    this.sceneid = sid;
};
/**
 * info可能是这种格式
 * {"id":"a1CCBQiM03h_test003","params":{"YellowLight":{"value":1,"time":1520864957757}}
 * 也可能是这种格式
 * {"id":"a1CCBQiM03h_test003","params":{"YellowLight":1}
 * @param  {[type]} info [description]
 * @return {[type]}      [description]
 */
DeviceTrigger.prototype.trigger = function (info) {
    log.i(TAG, "trigger.id = " + info.id + ", this.id = " + this.id);
    if (info.id !== this.id) {
        log.d(TAG, 'not for me');
        return false;
    }

    var params = info.params;
    if (!params) {
        log.w(TAG, 'params is empty');
        return false;
    }

    var myprop = this.params[Tag.PROPERTYNAME];
    if (!params.hasOwnProperty(myprop)) {
        log.w(TAG, 'no property: ' + myprop);
        return false;
    }

    var value = params[myprop];
    if (typeof value === 'object' && value !== null)
        value = value.value;
    var compare = this.params[Tag.COMPARETYPE];
    var checker = this.params[Tag.COMPAREVALUE];
    log.i(TAG, myprop, JSON.stringify(value), "target {", myprop, compare,  checker, "}");
    this.fullfilled = valuecomparer(compare, value, checker);
    log.i(TAG, "fullfilled = ", this.fullfilled);
    return this.fullfilled;
};

DeviceTrigger.prototype.eventHappen = function() {
    return false;
};

DeviceTrigger.prototype.start = function() {
    return true;
};

DeviceTrigger.prototype.stop = function() {
    return true;
};

module.exports = DeviceTrigger;
