#!/bin/bash

FC_MOUNT_SWITCH="on"
# Preparation for chroot START.Mount public dir.

HOME_DIR=`env | grep ^HOME= | cut -c 7-`
MOUNT_POINT=$(dirname $(readlink -f "$0"))
mount_array=($HOME_DIR sys lib lib64 tmp/var/run bin dev usr etc etc/resolv.conf proc linkedge/run linkedge/gateway/build/lib)

umount_fc() {
umount $MOUNT_POINT/$GW_LIB_DIR
umount $MOUNT_POINT/$GW_PYTHON_DIR
for dir in ${mount_array[@]}
do
    umount -l $MOUNT_POINT/$dir
done
}

mount_fc() {
#mount | grep cgroup | grep -v grep | awk '{print "umount " $3}' | sh
for dir in ${mount_array[@]}
do
    if [[ $dir != etc/resolv.conf ]]
    then
        mkdir -p $MOUNT_POINT/$dir
    fi

    if [[ ! $dir =~ cgroup ]]
    then
        mount --rbind /$dir $MOUNT_POINT/$dir
        mount --make-rslave $MOUNT_POINT/$dir
        if [[ $dir != tmp/var/run && $dir != linkedge/run ]]
        then
        mount -o remount,ro,bind --make-rslave /$dir $MOUNT_POINT/$dir
        fi
    fi
done

# The 3 lines below is for system compatibility
mkdir -p $MOUNT_POINT/var/run && touch $MOUNT_POINT/var/run/docker.sock
mount --bind /var/run/docker.sock $MOUNT_POINT/var/run/docker.sock
mkdir -p $MOUNT_POINT/$GW_LIB_DIR
#mount --bind $MOUNT_POINT/../../lib $MOUNT_POINT/$GW_LIB_DIR
#mount -o remount,ro,bind $MOUNT_POINT/../../lib $MOUNT_POINT/$GW_LIB_DIR
mkdir -p $MOUNT_POINT/$GW_PYTHON_DIR
mount --bind $MOUNT_POINT/../../bin/py3_venv $MOUNT_POINT/$GW_PYTHON_DIR
mount -o remount,ro,bind $MOUNT_POINT/../../bin/py3_venv $MOUNT_POINT/$GW_PYTHON_DIR
}

#create configure file
#mkdir -p /linkedge/run/fc
mkdir -p /linkedge/run/ifttt
killall -15 node
cp ../fc-base ./ -f
cp ../start-ea.sh ./ -f
cp ../stop-ea.sh ./ -f

if [ "$FC_MOUNT_SWITCH" == "on" ]; then
    GRAVITY_PATH=""
    GW_LIB_DIR=gw_lib
    GW_PYTHON_DIR=linkedge/gateway/build/bin/py3_venv
    umount_fc
    mount_fc
else
    GRAVITY_PATH=$(dirname $(readlink -f "$0"))
    GW_LIB_DIR=../../lib
fi

START_PARAM=$1
echo "start parameters:" $START_PARAM

ENV_PATH=$GRAVITY_PATH/build-env/node/bin
PYTHON_PATH=/linkedge/gateway/build/bin/py3_venv/bin
export PATH=$PYTHON_PATH:$ENV_PATH:$PATH
#Export C dependency library lookup PATH
#export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:$GRAVITY_PATH/$GW_LIB_DIR
#Export JS dependency library lookup PATH
export NODE_PATH=$GRAVITY_PATH/node_modules:$GRAVITY_PATH/developer:$GRAVITY_PATH/$GW_LIB_DIR:$NODE_PATH

#Set maximum thread number of libuv: not exceeding 128
export UV_THREADPOOL_SIZE=96
export PYTHONPATH=/gw_lib:$PYTHONPATH
export PYTHONUNBUFFERED=TRUE

#Start function-compute
APP="./fc-base"

ea_version=$EA_VERSION
if [ -n "$ea_version" ]; then
	echo "EA_VERSION is $ea_version "
	APP="./fc-base -e"
fi

if [ "$FC_MOUNT_SWITCH" == "on" ]; then
    #Chroot to run the function-compute
    chroot $MOUNT_POINT $APP &
else
    $APP &
fi
