'use strict';
var Log = {
    init : function () {
    },
    LOGD : function () {
        var info = stackInfo();
        var method = info['method'];
        var file = info['file'];
        var line = info['line'];
        var str = "";
        for (var i = 0; i < arguments.length; i++) {
            str += arguments[i] + " ";
        }
        console.log(`[DEBUG] [${method}@${file}:${line}]: ${str}`);
    },
    LOGI : function () {
        var info = stackInfo();
        var method = info['method'];
        var file = info['file'];
        var line = info['line'];
        var str = "";
        for (var i = 0; i < arguments.length; i++) {
            str += arguments[i] + " ";
        }
        console.log(`[INFO] [${method}@${file}:${line}]: ${str}`);
    },
    LOGE : function () {
        var info = stackInfo();
        var method = info['method'];
        var file = info['file'];
        var line = info['line'];
        var str = "";
        for (var i = 0; i < arguments.length; i++) {
            str += arguments[i] + " ";
        }
        console.log(`[ERROR] [${method}@${file}:${line}]: ${str}`);
    },
    /*最严重的错误*/
    LOGF : function () {
        var info = stackInfo();
        var method = info['method'];
        var file = info['file'];
        var line = info['line'];
        var str = "";
        for (var i = 0; i < arguments.length; i++) {
            str += arguments[i] + " ";
        }
        console.log(`[FATAL] [${method}@${file}:${line}]: ${str}`);
    },
    LOGM : function () {
        var info = stackInfo();
        var method = info['method'];
        var file = info['file'];
        var line = info['line'];
        var str = "";
        for (var i = 0; i < arguments.length; i++) {
            str += arguments[i] + " ";
        }
        console.log(`[MILESTONE] [${method}@${file}:${line}]: ${str}`);
    },
    LOGW : function () {
        var info = stackInfo();
        var method = info['method'];
        var file = info['file'];
        var line = info['line'];
        var str = "";
        for (var i = 0; i < arguments.length; i++) {
            str += arguments[i] + " ";
        }
        console.log(`[WARNING] [${method}@${file}:${line}]: ${str}`);
    }
};

function stackInfo() {
    var path = require('path');
    var stackReg = /at\s+(.*)\s+\((.*):(\d*):(\d*)\)/i;
    var stackReg2 = /at\s+()(.*):(\d*):(\d*)/i;
    var stacklist = (new Error()).stack.split('\n').slice(3);
    var s = stacklist[0];
    var sp = stackReg.exec(s) || stackReg2.exec(s);
    var data = {};
    if (sp && sp.length === 5) {
        data.method = sp[1];
        data.path = sp[2];
        data.line = sp[3];
        data.pos = sp[4];
        data.file = path.basename(data.path);
    }

    return data;
}
module.exports = Log;
